\documentclass{beamer}

\usetheme{Berlin}
\usecolortheme{dolphin}
\setbeameroption{hide notes}

%===Packages===%

\usepackage{amsmath}
\usepackage{amssymb}
\usepackage{amsthm}
\usepackage{graphicx}
\usepackage{hyperref}
\usepackage{subcaption}

%===Math Operators===%

\newcommand{\dxdy}[2]{\frac{d #1}{d #2}}
\newcommand{\dxdyk}[3]{\frac{d^{#3} #1}{d {#2}^{#3}}}
\newcommand{\pdxdy}[2]{\frac{\partial #1}{\partial #2}}
\newcommand{\liminfty}[1]{\lim_{#1 \to \infty}}
\newcommand{\limab}[2]{\lim_{#1 \to #2}}

\newcommand{\abs}[1]{\left \vert #1 \right \vert}
\newcommand{\norm}[1]{\left \Vert #1 \right \Vert}
\newcommand{\order}[1]{\mathcal{O} \left ( #1 \right )}
\newcommand{\set}[1]{\left \{ #1 \right \}}
\newcommand{\Set}[2]{\left \{ #1 \ \middle \vert \ #2 \right \}}
\newcommand{\vmat}[1]{\begin{vmatrix} #1 \end{vmatrix}}
\DeclareMathOperator{\sign}{sign}

\let\vec\mathbf

%===Important Sets===%

\newcommand{\bbn}{\mathbb{N}}
\newcommand{\bbz}{\mathbb{Z}}
\newcommand{\bbq}{\mathbb{Q}}
\newcommand{\bbr}{\mathbb{R}}
\newcommand{\bbc}{\mathbb{C}}
\newcommand{\bbf}{\mathbb{F}}

%===Types of Statements===%

\newtheorem{lem}{Lemma}
\newtheorem{thm}{Theorem}
\newtheorem{cor}{Corollary}
\newtheorem{prop}{Proposition}
\newtheorem{conj}{Conjecture}
\newtheorem{defn}{Definition}

\usepackage{setspace}
\usepackage{animate}
\usepackage{tikz}
\usetikzlibrary{calc,intersections,positioning,tikzmark,fit,3d}
\newcommand{\tetra}[2]{
    \filldraw[red] \foreach \x in {#1} {(\x) circle (1.5pt)};
    \filldraw[blue,fill opacity=0.2] (S1) -- (S2) -- (S3) -- (S4) -- cycle;
    \filldraw[red] \foreach \x in {#2} {(\x) circle (1.5pt)};
    }
\newcommand{\blueplane}[4]{
    \filldraw[blue,fill opacity=0.4] #1 -- #2 -- #3 -- #4 -- cycle;
    }
\newcommand{\redplanes}[4]{
    \filldraw[red,fill opacity=0.2] #1 -- #2 -- #3 -- cycle;
    \filldraw[red,fill opacity=0.2] #1 -- #2 -- #4 -- cycle;
    \filldraw[red,fill opacity=0.2] #1 -- #3 -- #4 -- cycle;
    }
\newcommand{\tikzint}[4]{{(#1*#4-#3*#2)/(#4-#2)}}
\newcommand{\Tetra}[9]{
	\coordinate (X1) at (#1,#2,#3); \coordinate (X2) at (#4,#5,#6); \coordinate (X3) at (-2,-2,-2); \coordinate (X4) at (#7,#8,#9);
		\coordinate (z1) at (\tikzint{#4}{#6}{#1}{#3},\tikzint{#5}{#6}{#2}{#3},0);
		\coordinate (z2) at (\tikzint{#4}{#6}{-2}{-2},\tikzint{#5}{#6}{-2}{-2},0);
		\coordinate (z3) at (\tikzint{#4}{#6}{#7}{#9},\tikzint{#5}{#6}{#8}{#9},0);
		\coordinate (z4) at (\tikzint{#7}{#9}{-2}{-2},\tikzint{#8}{#9}{-2}{-2},0);
		\coordinate (z5) at (\tikzint{#1}{#3}{-2}{-2},\tikzint{#2}{#3}{-2}{-2},0);
		\coordinate (z6) at (\tikzint{#7}{#9}{#1}{#3},\tikzint{#8}{#9}{#2}{#3},0);
		
		\coordinate (x1) at (0,\tikzint{#2}{#1}{#5}{#4},\tikzint{#3}{#1}{#6}{#4});
		\coordinate (x2) at (0,\tikzint{#2}{#1}{-2}{-2},\tikzint{#3}{#1}{-2}{-2});
		\coordinate (x3) at (0,\tikzint{#2}{#1}{#8}{#7},\tikzint{#3}{#1}{#9}{#7});
		\coordinate (x4) at (0,\tikzint{#8}{#7}{-2}{-2},\tikzint{#9}{#7}{-2}{-2});
		\coordinate (x5) at (0,\tikzint{-2}{-2}{#5}{#4},\tikzint{-2}{-2}{#6}{#4});
		\coordinate (x6) at (0,\tikzint{#8}{#7}{#5}{#4},\tikzint{#9}{#7}{#6}{#4});
	
	\draw[black] (0,-2,0) -- (0,2,0);
	\filldraw[blue,fill opacity=0.2] (2,-2,0) -- (2,2,0) -- (0,2,0) -- (0,2,-2) -- (0,-2,-2) -- (0,-2,0) -- cycle;
	\filldraw[red] \foreach \x in {(X1),(X2),(X3),(X4)} {\x circle (1.5pt)};
	\filldraw[red,fill opacity=0.2] (X1) -- (X2) -- (X3) -- cycle;
	\filldraw[red,fill opacity=0.2] (X1) -- (X2) -- (X4) -- cycle;
	\filldraw[red,fill opacity=0.2] (X4) -- (X2) -- (X3) -- cycle;
	\filldraw[red,fill opacity=0.2] (X1) -- (X4) -- (X3) -- cycle;
	\filldraw[blue,fill opacity=0.2] (-2,-2,0) -- (-2,2,0) -- (0,2,0) -- (0,2,2) -- (0,-2,2) -- (0,-2,0) -- cycle;
}

%\newcommand{\hvec}[2]{\vec{h} \left (#1 \mid #2 \right )}
\newcommand{\hvec}[2]{\vec{q}^{#1}_{#2}}
\newcommand{\pcoord}[2]{#2 \cdot \vec{e}_{#1}}
%\newcommand{\pcoord}[2]{p_{#1} \left ( #2 \right )}

%\newcommand{\snum}[3]{s \left ( #1, #2 \cup \set{#3} \right )}
\newcommand{\snum}[3]{s_{#2 \cup \set{#3}}^{#1}}
\newcommand{\snumalt}[2]{s_{#2}^{#1}}
%\newcommand{\sdenom}[2]{t \left ( #1, #2 \right )}
\newcommand{\sdenom}[2]{t_{#2}^{#1}}
\newcommand{\signq}[3]{\sign \left ( \pcoord{#3}{\hvec{#1}{#2}} \right )}

\usepackage[backend=bibtex,style=authoryear]{biblatex}
\ExecuteBibliographyOptions{doi=false, eprint=false, url=false}
\addbibresource{references.bib}
\setbeamerfont{footnote}{size=\tiny}

\title{Robust intersection algorithms for non-matching grids}
\author{Conor McCoid, Martin J. Gander}
\institute{Universit\'e de Gen\`eve}
\date{25.07.2022}

\begin{document}

\frame{\titlepage}

% Outline:
%	1. Motivating example
%		$ 2. Inconsistent calculations
%
%		$ 3. Consistency between steps
%		$ 4. Change of coordinates / ref simplies, invoke finite elements
%		$ 5. Binary sign function -- boundary is included, so in and on are the same
%		$ 11. Intersection calculations
%		$ 11a. For triangles
%		$ 11b. For tetrahedra
%
%		$ 6. Centrepiece: simplicial intersection algorithm
%
%	? 7. Triangles and tetrahedra -- particular cases for the algorithm
%	8. Proof
%		$ 9. Computational example(s)
%		$ 10. Implemenation -- combinadics, etc.

%---2. Inconsistent calculations---%

\begin{frame}
\frametitle{Why intersection algorithms are important}
\begin{figure}
\only<1>{\includegraphics[width=0.8\textwidth]{nba2k13_wade_clipping.png}}
\only<2>{\includegraphics[width=0.8\textwidth]{PorousMedia.jpg} \footnote[frame]{\cite{Zbigniew2012}}}
\only<3>{\includegraphics[width=0.8\textwidth]{FluidStructure.jpg} \footnote[frame]{\cite{Sasongko2009}}}
\end{figure}
\end{frame}

\begin{frame}
\frametitle{Failures of clipping algorithms}
  \begin{figure}
  \only<1>{\includegraphics[width=0.49\textwidth]{Jeronimo_fail.png}}
  \only<2>{\includegraphics[width=\textwidth]{MTLB_tetra_ExHecht_base.eps}}
  \only<3>{\includegraphics[width=\textwidth]{MTLB_tetra_ExHecht_skeleton.eps}}
  \only<4>{\href{run:MOV_EX_3DHecht.mp4}{\includegraphics[width=0.49\textwidth]{Hecht3D_fail.eps}}}
  \end{figure}
\end{frame}

%---3. Consistency---%

\begin{frame}
\frametitle{Towards consistency}
\textbf{Robust:} resistant to failure.

~

One way to be robust is to use parsimony:

\textbf{Parsimony:} the principle of using the fewest resources to solve a problem.

~

If an algorithm  is parsimonious it is self-consistent, meaning the result represents a possible accurate outcome, even if it's inaccurate for the given problem.
\end{frame}

%---4. Change of coordinates---%

\begin{frame}
\frametitle{Change of coordinates}
Simplex $V$ is transformed to reference simplex $Y$:
\begin{equation*}
\hat{V} = \vec{v_0} \vec{1}^\top + \begin{bmatrix} \vec{0} & \vec{v}_1 & \dots & \vec{v}_n \end{bmatrix} \to \begin{bmatrix} \vec{0} & \vec{e}_1 & \dots & \vec{e}_n \end{bmatrix} .
\end{equation*}

Simplex $U$ is transformed to simplex $X$ under the same transformation:
\begin{equation*}
\begin{bmatrix} \vec{v}_1 & \dots & \vec{v}_n \end{bmatrix} \begin{bmatrix} \vec{x}_0 & \dots & \vec{x}_n \end{bmatrix} = \hat{U} - \vec{v}_0 \vec{1}^\top .
\end{equation*}
\end{frame}

\begin{frame}
\frametitle{Reference simplices}
\begin{figure}
  \begin{tikzpicture}
  	\matrix[row sep=1em, column sep=1em, ampersand replacement=\ampersand]{
  	\draw[->, thick] (-0.5,0) -- (1.5,0) node[above] {$x'$}; \draw[->, thick] (0,-0.5) -- (0,1.5) node[right] {$y'$};
  	\filldraw[blue, opacity=0.5] (0.25,0.5) -- (1,0.1) -- (0.2,1.2) -- cycle;
  	\ampersand \draw[->, thick] (-0.5,0) -- (0.5,0); \ampersand
      \draw[->,thick] (-0.5,0) -- (1.5,0) node[above] {$x$}; \draw[->,thick] (0,-0.5) -- (0,1.5) node[right] {$y$};
      \filldraw[blue,opacity=0.5] (1,0) -- (0,1) -- (0,0) -- cycle; \\};
  \end{tikzpicture}
  \begin{tikzpicture}
  	\matrix[row sep=1em, column sep=1em, ampersand replacement=\ampersand, every cell/.style={rotate around y=0}]{
  	      \draw[->,thick] (-0.5,0,0) -- (1.5,0,0) node[below] {$x'$}; \draw[->,thick] (0,-0.5,0) -- (0,1.5,0) node[right] {$z'$}; \draw[->,thick] (0,0,-0.5) -- (0,0,1.5) node[right] {$y'$};
  	      \foreach \x in {(0.75,0.2,0.1), (0.3,0.15,1.25), (0.1,0.9,0.15)} {\draw[thick,blue] \x -- (0.5,0.2,0.3);}
  	      \filldraw[blue,opacity=0.5] (0.75,0.2,0.1) -- (0.3,0.15,1.25) -- (0.1,0.9,0.15) -- cycle;
  	      \ampersand \draw[->, thick] (-0.5,0,0) -- (0.5,0,0); \ampersand
      \draw[->,thick] (-0.5,0,0) -- (1.5,0,0) node[below] {$x$}; \draw[->,thick] (0,-0.5,0) -- (0,1.5,0) node[right] {$z$}; \draw[->,thick] (0,0,-0.5) -- (0,0,1.5) node[right] {$y$};
      \filldraw[blue,opacity=0.5] (1,0,0) -- (0,1,0) -- (0,0,1); \\};
  \end{tikzpicture}
\end{figure}
\end{frame}

%---5. Binary sign---%

\begin{frame}
\frametitle{Binary-valued sign function}
\begin{equation*}
    \sign(p) = \begin{cases} 1 & p \geq 0, \\ 0 & p < 0, \end{cases}
\end{equation*}
We only calculate an intersection between two points if they have different signs in a given direction.
\end{frame}

\begin{frame}
\begin{figure}
  \begin{tikzpicture}[scale=2]
    \filldraw[blue,opacity=0.25] (0,0) -- (0,1.5) -- (1.5,1.5) -- (1.5,0) -- cycle;
    \draw[->,thick] (-0.5,0) -- (1.5,0) node[below] {$q$}; \draw[->,thick] (0,-0.5) -- (0,1.5) node[left] {$p$};
    \coordinate (x1) at (0.5,1); \coordinate (x2) at (1,0.5); \coordinate (x3) at (0.75,-0.5); \coordinate (y1) at (0,0); \coordinate (y2) at (1,0);
    \filldraw[red] \foreach \x in {1,2,3} {(x\x) circle (1pt)}; \draw[red,thick] (x1)--(x2)--(x3)--cycle; \node[above] at (x1) {+ve}; \node[above] at (x2) {+ve}; \node[below] at (x3) {-ve};
    \draw[blue] (intersection of x1--x3 and y1--y2) circle (2pt); \draw[blue] (intersection of x2--x3 and y1--y2) circle (2pt);
  \end{tikzpicture}
\end{figure}
\end{frame}

\begin{frame}
\frametitle{Hyperplanes of $Y$}
\begin{definition}[Simplex 1]
A simplex in $\bbr^n$ is the intersection of $n+1$ half-spaces bounded by $n+1$ hyperplanes.
\end{definition}

Let $P_\gamma = \Set{\vec{x} \in \bbr^n}{\vec{x} \cdot \vec{e}_\gamma = 0}$.
The positive side of $P_\gamma$ is the space $\Set{\vec{x} \in \bbr^n}{\vec{x} \cdot \vec{e}_\gamma \geq 0}$.
\end{frame}

\begin{frame}
\begin{figure}
  \centering
  \begin{tikzpicture}
        \coordinate (A1) at (-1,-1); \node[left] at (A1) {-ve};
        \coordinate (B1) at (0,-0.75); \node[left] at (B1) {-ve};
        \coordinate (C1) at (-0.5,1); \node[left] at (C1) {-ve};
        \coordinate (D2) at (2,-1); \node[right] at (D2) {+ve};
        \coordinate (S1) at (0,-2);
        \coordinate (S2) at (0,2);
        \coordinate (S3) at (2,1);
        \coordinate (S4) at (2,-1);
        \coordinate (int1) at ($.5*(A1)+.5*(D2)$);
        \coordinate (int2) at ($.5*(B1)+.5*(D2)$);
        \coordinate (int3) at ($.5*(C1)+.5*(D2)$);
                \tetra{A1,B1,C1}{D2} \redplanes{(A1)}{(B1)}{(C1)}{(D2)} \blueplane{(int1)}{(int2)}{(int3)}{(int3)};
  \end{tikzpicture}
\end{figure}
\end{frame}

%---11. Intersections (general)---%

\begin{frame}
\frametitle{$m$-faces of $X$}
\begin{definition}[Simplex 2]
A simplex in $\bbr^n$ is the convex hull between $n+1$ vertices.
\end{definition}

An $m$-face of $X$ is the convex hull between $m$ of its vertices,
ie. three vertices form a triangle, four a tetrahedron, etc.
\end{frame}

\begin{frame} % nb: this is a good frame for MANIM, swapping the columns around to show the corollary
\frametitle{Intersection between an $m$-face of $X$ and $m$ hyperplanes of $Y$}
\only<1,2>{
\begin{equation*}
\pcoord{\eta}{ \hvec{J}{\Gamma} } = \frac{\begin{vmatrix} \pcoord{\eta}{\vec{x}_{i_0}} & \pcoord{\gamma_1}{\vec{x}_{i_0}} & \dots & \pcoord{\gamma_m}{\vec{x}_{i_0}} \\ \vdots & \vdots & & \vdots \\ \pcoord{\eta}{\vec{x}_{i_m}} & \pcoord{\gamma_1}{\vec{x}_{i_m}} & \dots & \pcoord{\gamma_m}{\vec{x}_{i_m}} \end{vmatrix}}{
\begin{vmatrix} 1 & \pcoord{\gamma_1}{\vec{x}_{i_0}} & \dots & \pcoord{\gamma_m}{\vec{x}_{i_0}} \\ \vdots & \vdots & & \vdots \\ 1 & \pcoord{\gamma_1}{\vec{x}_{i_m}} & \dots & \pcoord{\gamma_m}{\vec{x}_{i_m}} \end{vmatrix}}
\end{equation*}
}
\only<3>{
\begin{equation*}
\pcoord{\gamma_1}{ \hvec{J}{\Gamma_{\gamma_1}} } = \frac{\begin{vmatrix} \pcoord{\gamma_1}{\vec{x}_{i_0}} & \pcoord{\eta}{\vec{x}_{i_0}} & \dots & \pcoord{\gamma_m}{\vec{x}_{i_0}} \\ \vdots & \vdots & & \vdots \\ \pcoord{\gamma_1}{\vec{x}_{i_m}} & \pcoord{\eta}{\vec{x}_{i_m}} & \dots & \pcoord{\gamma_m}{\vec{x}_{i_m}} \end{vmatrix}}{
\begin{vmatrix} 1 & \pcoord{\eta}{\vec{x}_{i_0}} & \dots & \pcoord{\gamma_m}{\vec{x}_{i_0}} \\ \vdots & \vdots & & \vdots \\ 1 & \pcoord{\eta}{\vec{x}_{i_m}} & \dots & \pcoord{\gamma_m}{\vec{x}_{i_m}} \end{vmatrix}}
\end{equation*}
}

\only<2,3>{
\begin{corollary} \label{simplices cor: numerators}
The numerator of $\pcoord{\eta}{ \hvec{J}{\Gamma} }$ is shared with the numerators of $\pcoord{j}{ \hvec{J}{\Gamma_j} }$ for $m$ values of $j$, up to a change in sign, where $\Gamma$ and $\Gamma_j$ have cardinality $m$.
\end{corollary}
}
\end{frame}

%---11a. Intersections (triangles)---%

\begin{frame}
\frametitle{Intersections for triangles}
\begin{table}
  \begin{tabular}{c|c|c}
    Edge/Line & Distance from 1st vertex & Distance from 2nd vertex \\ \hline
    $y=0$ & $\frac{x_i y_j - x_j y_i}{y_j - y_i}$ & $\frac{(1-x_i)y_j - (1-x_j)y_i}{y_j-y_i}$ \\
    $x=0$ & $\frac{x_i y_j - x_j y_i}{x_i - x_j}$ & $\frac{(1-y_i)x_j - (1-y_j)x_i}{x_j-x_i}$ \\
    $x+y=1$ & $\frac{(1-x_i)y_j - (1-x_j)y_i}{x_i + y_i-x_j -y_j}$ & $\frac{(1-y_i)x_j - (1-y_j)x_i}{x_j + y_j-x_i -y_i}$
  \end{tabular}
\end{table}
\end{frame}

%---11b. Intersections (tetrahedra)---%

\begin{frame}
\frametitle{1st type of intersections for tetrahedra}
\begin{table}
	\centering
	\scalebox{0.9}{
	\begin{tabular}{c||c|c|c}
	Plane $P$ & Num. of $q_\gamma^{ij}$ & Num. of $r_\gamma^{ij}$ & Num. of $1-q_\gamma^{ij}-r_\gamma^{ij}$ \\ \hline \hline
	$x=0$ & \tikzmark{start1}$\begin{vmatrix} x_i & y_i \\ x_j & y_j \end{vmatrix}$\tikzmark{end1} & $\begin{vmatrix} x_i & z_i \\ x_j & z_j \end{vmatrix}$ & $\begin{vmatrix} x_i & 1-y_i-z_i \\ x_j & 1- y_j-z_j \end{vmatrix}$ \\ \hline
	$y=0$ & $\begin{vmatrix} y_i & z_i \\ y_j & z_j \end{vmatrix}$ & \tikzmark{start2}$\begin{vmatrix} y_i & x_i \\ y_j & x_j \end{vmatrix}$\tikzmark{end2} & $\begin{vmatrix} y_i & 1-x_i-z_i \\ y_j & 1-x_j-z_j \end{vmatrix}$ \\ \hline
	$z=0$ & $\begin{vmatrix} z_i & x_i \\ z_j & x_j \end{vmatrix}$ & $\begin{vmatrix} z_i & y_i \\ z_j & y_j \end{vmatrix}$ & $\begin{vmatrix} z_i & 1-x_i-y_i \\ z_j & 1-x_j-y_j \end{vmatrix}$ \\ \hline
	$x+y+z=1$ & $\begin{vmatrix} 1-y_i-z_i & x_i \\ 1-y_j-z_j & x_j \end{vmatrix}$ & $\begin{vmatrix} 1-x_i-z_i & y_i \\ 1-x_j-z_j & y_j \end{vmatrix}$ & $\begin{vmatrix} 1-x_i-y_i & z_i \\ 1-x_j-y_j & z_j \end{vmatrix}$
	\end{tabular}
\pause{\begin{tikzpicture}[remember picture, overlay]
  \foreach \x in {1,2} {
  \node[draw,line width=2pt,red,rectangle,inner ysep=15pt,fit={(pic cs:start\x) (pic cs:end\x)}] {};
  };
\end{tikzpicture}}
	}
\end{table}
\end{frame}

\begin{frame}
\frametitle{Pairings}
\note{
So what does this mean?
In the 2D case, pairing the intersections together meant the edge of X moved as a unit.
The same is true in the 3D case.
The sign of the numerator informs us on which side of the edge of Y the edge of X falls.}

\begin{figure}
  \centering
  \begin{tikzpicture}[rotate around y=60]
    \matrix[row sep=1em, column sep=1em, every cell/.style={scale=0.75},ampersand replacement=\ampersand]{
			\Tetra{-1}{0}{0.5}{0.5}{0}{-1}{1.5}{-2}{2.5}
			\draw[blue] (x1) -- (x3) -- (x4) -- (x5) -- cycle; \draw[blue] (z1) -- (z3) -- (z4) -- (z5) -- cycle;
			\filldraw[blue] (x1) circle (1.5pt); \filldraw[blue] (z1) circle (1.5pt);
			\filldraw[black] (intersection of z1--z3 and x1--x3) circle (1.5pt);
			\draw[black] (intersection of z3--z4 and x4--x5) circle (2pt);
			\ampersand
			\draw[<->,rotate around y=-60, very thick] (0,0,0) -- (1,0,0);
			\ampersand
			\Tetra{1}{0}{-0.5}{-0.5}{0}{1}{1.5}{-2}{2.5}
			\draw[blue] (x1) -- (x2) -- (x4) -- (x6) -- cycle; \draw[blue] (z1) -- (z2) -- (z4) -- (z6) -- cycle;
			\filldraw[blue] (x1) circle (1.5pt); \filldraw[blue] (z1) circle (1.5pt);
			\filldraw[black] (intersection of z1--z2 and x1--x2) circle (1.5pt);
			\draw[black] (intersection of z6--z4 and x4--x2) circle (2pt);
			\\};
  \end{tikzpicture}
\end{figure}
\end{frame}

\begin{frame}
\frametitle{2nd type of intersections for tetrahedra}
\newcommand{\detijk}{\begin{vmatrix} x_i & y_i & z_i \\ x_j & y_j & z_j \\ x_k & y_k & z_k \end{vmatrix}}
\begin{table}
  \centering
  \scalebox{0.8}{
  \begin{tabular}{c||c|c|c|c}
  Edge of $Y$ & $y,z$ & $x,z$ & $x,y$ & \dots \\ \hline \hline
  Num. of $t^{ijk}$ & \tikzmark{start3}$\detijk$ & $\detijk$ & $\detijk$\tikzmark{end3} \\ \hline
  Num. of $1-t^{ijk}$ & $\begin{vmatrix} 1-x_i & y_i & z_i \\ 1-x_j & y_j & z_j \\ 1-x_k & y_k & z_k \end{vmatrix}$ & $\begin{vmatrix} x_i & 1-y_i & z_i \\ x_j & 1-y_j & z_j \\ x_k & 1-y_k & z_k \end{vmatrix}$ & $\begin{vmatrix} x_i & y_i & 1-z_i \\ x_j & y_j & 1-z_j \\ x_k & y_k & 1-z_k \end{vmatrix}$
  \end{tabular}
  \pause{\begin{tikzpicture}[remember picture, overlay]
  \node[draw,line width=2pt,red,rectangle,inner ysep=23pt,fit={(pic cs:start3) (pic cs:end3)}] {};
  \end{tikzpicture}}
  }
\end{table}
\end{frame}

\begin{frame}
\frametitle{Triplings}
\note{
The tripling of the Y with X intersections collects the intersections found on a given face of X.
Now the sign of the numerator defines which side of the vertex of Y the face of X falls on, and by extension whether the vertex of Y is in X or not.}

\begin{figure}
  \centering
  \begin{tikzpicture}[rotate around y=-20]
    \matrix[row sep=1em, column sep=1em,ampersand replacement=\ampersand]{
		\draw[black] (-2,0,0) -- (2,0,0); \draw[black] (0,-2,0) -- (0,2,0); \draw[black] (0,0,-2) -- (0,0,2);
		\filldraw[blue,opacity=0.2] (0,0,0) -- (-2,0,0) -- (-2,2,0) -- (0,2,0) -- cycle;
		\filldraw[blue,opacity=0.2] (0,0,0) -- (-2,0,0) -- (-2,0,2) -- (0,0,2) -- cycle;
		\filldraw[red,opacity=0.5] (-1,0,0) -- (0,1,0) -- (0,0,1) -- cycle;
		\filldraw[blue,opacity=0.2] (0,0,0) -- (0,0,2) -- (0,2,2) -- (0,2,0) -- cycle;
		\filldraw[blue] (-1,0,0) circle (1.5pt); \filldraw[blue] (0,1,0) circle (1.5pt); \filldraw[blue] (0,0,1) circle (1.5pt);
		\filldraw[black] (0,0,0) circle (1.5pt);
		\ampersand
			\draw[<->,rotate around y=20, very thick] (0,0,0) -- (1,0,0);
		\ampersand
		\draw[black] (-2,0,0) -- (2,0,0); \draw[black] (0,-2,0) -- (0,2,0); \draw[black] (0,0,-2) -- (0,0,2);
		\filldraw[blue,opacity=0.2] (0,0,0) -- (-2,0,0) -- (-2,2,0) -- (0,2,0) -- cycle;
		\filldraw[blue,opacity=0.2] (0,0,0) -- (-2,0,0) -- (-2,0,2) -- (0,0,2) -- cycle;
		\filldraw[red,opacity=0.5] (1,0,0) -- (0,-1,0) -- (0,0,-1) -- cycle;
		\filldraw[blue,opacity=0.2] (0,0,0) -- (0,0,2) -- (0,2,2) -- (0,2,0) -- cycle;
		\filldraw[blue] (1,0,0) circle (1.5pt); \filldraw[blue] (0,-1,0) circle (1.5pt); \filldraw[blue] (0,0,-1) circle (1.5pt);
		\filldraw[black] (0,0,0) circle (1.5pt);
			\\};
  \end{tikzpicture}
\end{figure}
\end{frame}

%---6. Centrepiece---%
\begin{frame}

\frametitle{Simplicial intersection algorithm}
\textbf{Step 1:} Change of coordinates
\begin{equation*}
\begin{bmatrix} \vec{v}_1 & \dots & \vec{v}_n \end{bmatrix} \begin{bmatrix} \vec{x}_0 & \dots & \vec{x}_n \end{bmatrix} = \hat{U} - \vec{v}_0 \vec{1}^\top .
\end{equation*}

\textbf{Step 2:} Vertices of $X$ in $Y$
\begin{equation*}
\prod_{\gamma} \sign(\vec{x}_i \cdot \vec{e}_\gamma) = 1 \implies \vec{x}_i \in Y
\end{equation*}
\end{frame}

\begin{frame}
\frametitle{Simplicial intersection algorithm}
\textbf{Step 3:} Intersections of $X$ with $Y$

\hspace{2em} \textbf{Step 3(i):} Intersection magnitude
\begin{equation*}
\pcoord{\eta}{ \hvec{J}{\Gamma} } = \frac{\begin{vmatrix} \pcoord{\eta}{\vec{x}_{i_0}} & \pcoord{\gamma_1}{\vec{x}_{i_0}} & \dots & \pcoord{\gamma_m}{\vec{x}_{i_0}} \\ \vdots & \vdots & & \vdots \\ \pcoord{\eta}{\vec{x}_{i_m}} & \pcoord{\gamma_1}{\vec{x}_{i_m}} & \dots & \pcoord{\gamma_m}{\vec{x}_{i_m}} \end{vmatrix}}{
\begin{vmatrix} 1 & \pcoord{\gamma_1}{\vec{x}_{i_0}} & \dots & \pcoord{\gamma_m}{\vec{x}_{i_0}} \\ \vdots & \vdots & & \vdots \\ 1 & \pcoord{\gamma_1}{\vec{x}_{i_m}} & \dots & \pcoord{\gamma_m}{\vec{x}_{i_m}} \end{vmatrix}}
\end{equation*}
\end{frame}

\begin{frame}
\frametitle{Simplicial intersection algorithm}
\hspace{2em}  \textbf{Step 3(ii):} Intersection signs
\begin{columns}
\begin{column}{0.4\textwidth}
If there aren't $m$ intersections for a given $m$-face of $X$ then the signs of their numerators can be determined without calculations.
Otherwise, only one needs to be calculated and the rest become known.
\end{column}
\begin{column}{0.4\textwidth}
\begin{figure}
    \centering
    \begin{tikzpicture}
        \coordinate (y1) at (0,0) node[above right] {$Y$}; \coordinate (y2) at (0,3); \coordinate (y3) at (3,0);
        \coordinate (x1) at (1,1); \coordinate (x2) at (3,-1);
        \coordinate (int) at (intersection of y1--y3 and x1--x2);
        \draw[gray,thick,dashed] (-1,4) -- (4,-1);
        \draw[gray,thick] (y1)--(y2)--(y3)--cycle;
        \draw[gray,thick] (x1)--(x2); \filldraw[blue] (int) circle (3pt);
        \filldraw[red] \foreach \x in {y1,y2,y3,x1,x2} {(\x) circle (3pt)};
        \draw[->,black,very thick] (1.5,1.5) -- (x1);
        \draw[->,black,very thick] (3.5,-0.5) -- (x2);
        \draw[->,black,very thick] (2.5,0.5) -- (int);
    \end{tikzpicture}
\end{figure}
\end{column}
\end{columns}
\end{frame}

\begin{frame}
\frametitle{Simplicial intersection algorithm}
\hspace{2em}  \textbf{Step 3(iii):} Reverse transformation
\begin{equation*}
\vec{w}_\Gamma^J = \vec{v}_0 + \sum_{\gamma \notin \Gamma \cup \set{0}} \left ( \pcoord{\gamma}{ \hvec{J}{\Gamma} } \right ) \cdot \vec{v}_\gamma
\end{equation*}
\end{frame}

\begin{frame}
\frametitle{Simplicial intersection algorithm}
\textbf{Step 4:} Vertices of $Y$ in $X$

At the highest order, every $\Gamma$ has 2 planes not inside it.
There are only two intersections for this collection.
If they have different signs for one of the planes not in $\Gamma$ then the vertex for the other plane lies in $X$.

Essentially, there's one more intersection calculation but since we're at the highest order the intersection lies in a 0-dimensional space, the vertex of $Y$.
\end{frame}

%---9. Computational examples---%
%nb: more MANIM?

\begin{frame}
\frametitle{Computational examples}
\begin{figure}
	\centering
	\includegraphics[width=\textwidth]{MTLB_tetra_ExHecht.eps}
\end{figure}
\end{frame}

\begin{frame}
\frametitle{Computational examples}
\begin{figure}
	\centering
	\href{run:MOV_EX_3DAcc.mp4}{\includegraphics[width=\textwidth]{MTLB_tetra_ExAcc_samples_20220510.eps}}
\end{figure}
\end{frame}

\begin{frame}
\frametitle{Computational examples}
\begin{figure}
	\centering
	\includegraphics[width=\textwidth]{MTLB_tetra_ExAcc_20220510.eps}
	\caption{Relative error (left) and computation time (right)}
\end{figure}
\end{frame}

%---10. Implementation---%

% Combinadics
\begin{frame}
\frametitle{Adjacent intersections}
At intermediate steps in the algorithm we compare the signs of intersections to see if we need to calculate an intersection.
But only those pairs of intersections whose edges are on the \textit{outside} of $X$ are important;
those \textit{inside} won't be seen inside the convex intersection.

~

An edge will lie outside if the two index sets $J$ and $K$ of its points differ by one element, ie.
\begin{equation*}
|J \cap K| = |J| - 1 = |K| - 1.
\end{equation*}
We say the two sets are adjacent.
\end{frame}

\begin{frame}
\frametitle{Combinadics}
Checking which $J$ and $K$ are adjacent can be costly.
Luckily, there's a possible shortcut.

~

Each $J$ and $K$ represents a combination of the numbers $\set{0,\dots,n}$ and so can be ranked using the combinatorial number system:
\begin{equation*}
N(J) = \binom{c_m}{m} + \dots + \binom{c_1}{1} \in \set{0,\dots,\binom{n}{m}-1}
\end{equation*}
where $J = \set{c_j}_{j=1}^m$, $c_1 < c_2 < \dots < c_m$.
\end{frame}

\begin{frame}
\frametitle{Combinadic adjacency matrix}
Then, we can construct an adjacency matrix for the nodes $N(J)$:
\begin{lemma} \label{simplices lem: recurrence}
For $n > m > 1$
\begin{equation}
A_m^n = \begin{bmatrix} A^{n-1}_m & \tilde{A}_m^n \\ (\tilde{A}_m^n)^\top & A_{m-1}^{n-1} \end{bmatrix}, \quad \tilde{A}_m^n = \begin{bmatrix} \tilde{A}_m^{n-1} & 0_{\binom{n-2}{m-2} \times \binom{n-2}{m}} \\ I_{\binom{n-2}{m-1}} & \tilde{A}_{m-1}^{n-1} \end{bmatrix},
\end{equation}
with starting conditions
\begin{equation}
A_1^n = \begin{bmatrix} 0 & 1 & \dots & 1 \\ 1 & 0 & \ddots & \vdots \\ \vdots & \ddots & \ddots & 1 \\ 1 & \dots & 1 & 0 \end{bmatrix}, \quad \tilde{A}_1^n = \begin{bmatrix} 1 \\ \vdots \\ 1 \end{bmatrix}, \quad \tilde{A}_2^4 = \begin{bmatrix} 1 & 1 & 0 \\ 1 & 0 & 1 \\ 0 & 1 & 1 \end{bmatrix} .
\end{equation}
\end{lemma}
\end{frame}

% Signs
\begin{frame}
\frametitle{Sign connectivity}
We saw how the numerators of $\pcoord{\eta}{ \hvec{J}{\Gamma} }$ are connected, but what about the denominators?
These can be constructed from previous steps ($X_J$ are the vectors $\vec{x}_j$ with $j \in J$, $I_\Gamma$ the $\vec{e}_\gamma$ with $\gamma \in \Gamma$):
\begin{lemma} \label{simplices lem: sdenom}
Suppose $\signq{J \setminus \set{i}}{\Gamma}{\eta} \neq \signq{J \setminus \set{j}}{\Gamma}{\eta}$ and an intersection $\hvec{J \setminus \set{i,j}}{\Gamma \setminus \set{\gamma}}$ was calculated for some $\gamma \in \Gamma$, then
\begin{align*}
\sign \left ( \begin{vmatrix} \vec{1} & X_J^\top I_{\Gamma \cup \set{\eta}} \end{vmatrix} \right ) = &
\sign \left ( \begin{vmatrix} X_{J \setminus \set{i}}^\top I_{\Gamma \cup \set{\eta}} \end{vmatrix}
\begin{vmatrix} X_{J \setminus \set{i,j}}^\top I_\Gamma \end{vmatrix} 
\begin{vmatrix} \vec{1} & X_{J \setminus \set{j}}^\top I_\Gamma \end{vmatrix} \right )
\end{align*}
\end{lemma}
\end{frame}

\begin{frame}
\frametitle{Sign connectivity}
If the intersection $\hvec{J \setminus \set{i,j}}{\Gamma \setminus \set{\gamma}}$ from the last lemma wasn't calculated then we need another way to find the sign of $\begin{vmatrix} X_{J \setminus \set{i,j}}^\top I_\Gamma \end{vmatrix}$.
\begin{lemma}
Suppose $\signq{J \setminus \set{i}}{\Gamma}{\gamma} = \signq{J \setminus \set{j}}{\Gamma}{\gamma}$ for all $\gamma \notin \Gamma$.
Then, for all $\eta \notin \Gamma$,
\begin{align*}
\begin{vmatrix} X^\top_J I_{\Gamma \cup \set{\eta,\gamma}} \end{vmatrix} = & \begin{vmatrix} \pcoord{\eta}{\hvec{J \setminus \set{i}}{\Gamma}} & \pcoord{\gamma}{\hvec{J \setminus \set{i}}{\Gamma}} \\ \pcoord{\eta}{\hvec{J \setminus \set{j}}{\Gamma}} & \pcoord{\gamma}{\hvec{J \setminus \set{j}}{\Gamma}} \end{vmatrix}
	\frac{
	\begin{vmatrix} \vec{1} & X_{J \setminus \set{i}}^\top I_\Gamma \end{vmatrix}
	\begin{vmatrix} \vec{1} & X_{J \setminus \set{j}}^\top I_\Gamma \end{vmatrix}}{
	\begin{vmatrix} X_{J \setminus \set{i,j}}^\top I_\Gamma \end{vmatrix}}
\end{align*}
\end{lemma}
\end{frame}

\begin{frame}
\printbibliography
\end{frame}

\end{document}